﻿using System;
using System.Collections.Generic;
using System.Text;

namespace imlac
{
    // TODO: make memory size configurable.
    public class Memory
    {
        public Memory(ImlacSystem system)
        {
            _mem = new ushort[Size];
            _system = system;
        }

        public ushort Fetch(ushort address)
        {
            return _mem[address & SizeMask];
        }

        public void Store(ushort address, ushort word)
        {
            _mem[address & SizeMask] = word;

            // Invalidate processor caches
            _system.Processor.InvalidateCache(address);
            _system.DisplayProcessor.InvalidateCache(address);
        }

        public ushort Size
        {
            get { return 8192; }
        }

        public ushort SizeMask
        {
            get { return 0x1fff; }
        }

        private ushort[] _mem;
        private ImlacSystem _system;
    }
}
